package main

import (
	"fmt"
	"math/rand"
	"strconv"
	"strings"
)

type requestLine struct {
	Method      string //1
	URI         string //2
	Protocol    string //3
	HTTPVersion string //4
}

// func contains(s []string, e string) bool {
// 	for _, a := range s {
// 		if strings.EqualFold(a, e) {
// 			return true
// 		}
// 	}
// 	return false
// }
func randomChar() string {
	charSlice := strings.Split(charset, "")
	v := rand.Intn(len(charSlice))
	return string(charSlice[v])
}

var reqMap = make(map[string]int)

func inMap(reqLine string) bool {
	if _, ok := reqMap[reqLine]; !ok {
		reqMap[reqLine]++
		return true
	} else {
		return false
	}
}

var removedCount int
var replacedCount int
var donorCount int
var insertedCount int
var digits string = "0123456789"
var charset string = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ!@#$%^&*()-_=+"

func main() {
	// fmt.Println(randomChar)
	// fmt.Println(randomChar)
	// fmt.Println(randomChar)
	// fmt.Println(randomChar)
	// time.Sleep(10 * time.Minute)
	baselineGET := createRequest("GET", "/", "HTTP", "1.1")
	baselineOPTIONS := createRequest("OPTIONS", "/", "HTTP", "1.1")
	baselineHEAD := createRequest("HEAD", "/", "HTTP", "1.1")

	// baselinePATCH := createRequest("PATCH", "/", "HTTP", "1.1")
	// baselineCONNECT := createRequest("CONNECT", "/", "HTTP", "1.1")
	baselineDELETE := createRequest("DELETE", "/", "HTTP", "1.1")
	baselineTRACE := createRequest("TRACE", "/", "HTTP", "1.1")
	for i := 1; i <= 4; i++ {

		insertCharacter(baselineGET, i)
		insertCharacter(baselineOPTIONS, i)
		insertCharacter(baselineHEAD, i)
		insertCharacter(baselineDELETE, i)
		insertCharacter(baselineTRACE, i)

		// time.Sleep(10 * time.Second)
		if i != 2 {
			removeCharacter(baselineGET, i)
			removeCharacter(baselineOPTIONS, i)
			removeCharacter(baselineHEAD, i)
			removeCharacter(baselineDELETE, i)
			removeCharacter(baselineTRACE, i)

			replaceCharacter(baselineGET, i)
			replaceCharacter(baselineOPTIONS, i)
			replaceCharacter(baselineHEAD, i)
			replaceCharacter(baselineDELETE, i)
			replaceCharacter(baselineTRACE, i)
		}
		// fmt.Println("___")
	}
	fmt.Printf("Removed: %d, Replaced: %d, Inserted: %d, Starting requests: %d, Total: %d", removedCount, replacedCount, insertedCount, donorCount, donorCount+replacedCount+removedCount+insertedCount)
	// fmt.Println(reqMap)
}

func removeCharacter(request requestLine, part int) {
	switch {
	case part == 1:
		a := len(request.Method)
		fmt.Println(request.Method, request.URI, request.Protocol, request.HTTPVersion, "base_"+request.Method)
		for i := 0; i < a; i++ {
			temp := request.Method[i]
			c := strings.Replace(request.Method, string(temp), "", 1)
			if c != request.Method {
				finalString := c + " " + request.URI + " " + request.Protocol + " " + request.HTTPVersion
				if inMap(finalString) {
					fmt.Println(c, request.URI, request.Protocol, request.HTTPVersion, "rm1_"+request.Method+"_"+strconv.Itoa(i))
					removedCount++
				}
			}
		}
	case part == 2: //we dont need this.
		a := len(request.URI)
		// fmt.Println(request.Method, request.URI, request.Protocol, request.HTTPVersion, "base_"+request.Method)
		for i := 0; i < a; i++ {
			temp := request.URI[i]
			c := strings.Replace(request.URI, string(temp), "", 1)
			if c != request.URI {
				finalString := request.Method + " " + c + " " + request.Protocol + " " + request.HTTPVersion
				if inMap(finalString) {
					fmt.Println(request.Method, c, request.Protocol, request.HTTPVersion, "rm2_"+request.Method+"_"+strconv.Itoa(i))
					removedCount++
				}
			}

		}
	case part == 3:
		a := len(request.Protocol)
		// fmt.Println(request.Method, request.URI, request.Protocol, request.HTTPVersion, "base_"+request.Method)
		for i := 0; i < a; i++ {
			temp := request.Protocol[i]
			c := strings.Replace(request.Protocol, string(temp), "", 1)
			if c != request.Protocol {
				finalString := request.Method + " " + request.URI + " " + c + " " + request.HTTPVersion
				if inMap(finalString) {
					fmt.Println(request.Method, request.URI, c, request.HTTPVersion, "rm3_"+request.Method+"_"+strconv.Itoa(i))
					removedCount++
				}
			}

		}
	case part == 4:
		a := len(request.HTTPVersion)
		// fmt.Println(request.Method, request.URI, request.Protocol, request.HTTPVersion, "base_"+request.Method)
		for i := 0; i < a; i++ {
			temp := request.HTTPVersion[i]
			c := strings.Replace(request.HTTPVersion, string(temp), "", 1)
			if c != request.HTTPVersion {
				finalString := request.Method + " " + request.URI + " " + request.Protocol + " " + c
				if inMap(finalString) {
					fmt.Println(request.Method, request.URI, request.Protocol, c, "rm4_"+request.Method+"_"+strconv.Itoa(i))
					removedCount++
				}
			}

		}
	}
}

func insertCharacter(request requestLine, part int) {
	switch {
	case part == 1:
		for i := 1; i <= 257; i++ {
			c := request.Method + strings.Repeat("A", i)
			if c != request.Method {
				finalString := c + " " + request.URI + " " + request.Protocol + " " + request.HTTPVersion
				if inMap(finalString) {
					fmt.Println(c, request.URI, request.Protocol, request.HTTPVersion, "ins1_"+request.Method+"_"+strconv.Itoa(i))
					insertedCount++
				}
			}

		}
	case part == 2:
		for i := 1; i <= 257; i++ {
			c := request.URI + strings.Repeat("A", i)
			if c != request.URI {
				finalString := request.Method + " " + c + " " + request.Protocol + " " + request.HTTPVersion
				if inMap(finalString) {
					fmt.Println(request.Method, c, request.Protocol, request.HTTPVersion, "ins2_"+request.Method+"_"+strconv.Itoa(i))
					insertedCount++
				}
			}

		}
	case part == 3:
		for i := 1; i <= 257; i++ {
			c := request.Protocol + strings.Repeat("A", i)
			if c != request.Protocol {
				finalString := request.Method + " " + request.URI + " " + c + " " + request.HTTPVersion
				if inMap(finalString) {
					fmt.Println(request.Method, request.URI, c, request.HTTPVersion, "ins3_"+request.Method+"_"+strconv.Itoa(i))
					insertedCount++
				}
			}

		}
	case part == 4:
		for i := 1; i <= 257; i++ {
			c := request.HTTPVersion + strings.Repeat("1", i)
			if c != request.HTTPVersion {
				finalString := request.Method + " " + request.URI + " " + request.Protocol + " " + c
				if inMap(finalString) {
					fmt.Println(request.Method, request.URI, request.Protocol, c, "ins4_"+request.Method+"_"+strconv.Itoa(i))
					insertedCount++
				}
			}

		}
	}
}

func replaceCharacter(request requestLine, part int) {
	switch {
	case part == 1:
		a := len(request.Method)
		count := 1
		// fmt.Println(request.Method, request.URI, request.Protocol, request.HTTPVersion, "base_"+request.Method)
		for i := 0; i < a; i++ {
			temp := request.Method[i]
			for x := 0; x < len(charset); x++ {
				c := strings.Replace(request.Method, string(temp), string(charset[x]), 1)
				if c != request.Method && string(temp) != string(charset[x]) {
					finalString := c + " " + request.URI + " " + request.Protocol + " " + request.HTTPVersion
					if inMap(finalString) {
						fmt.Println(c, request.URI, request.Protocol, request.HTTPVersion, "sw1_"+request.Method+"_"+strconv.Itoa(count))
						replacedCount++
						count++
					}
				}

			}
			// c := strings.Replace(request.Method, string(temp), string(charset[rand.Intn(len(charset))]), 1)
		}
	case part == 2: //we dont need this.
		a := len(request.URI)
		count := 1
		// fmt.Println(request.Method, request.URI, request.Protocol, request.HTTPVersion, "base_"+request.Method)
		for i := 0; i < a; i++ {
			temp := request.URI[i]
			for x := 0; x < len(charset); x++ {
				c := strings.Replace(request.URI, string(temp), string(charset[rand.Intn(len(charset))]), 1)
				if c != request.URI && string(temp) != string(charset[x]) {
					finalString := request.Method + " " + c + " " + request.Protocol + " " + request.HTTPVersion
					if inMap(finalString) {
						fmt.Println(request.Method, c, request.Protocol, request.HTTPVersion, "sw2_"+request.Method+"_"+strconv.Itoa(count))
						replacedCount++
						count++
					}

				}

			}
		}
	case part == 3:
		a := len(request.Protocol)
		count := 1
		// fmt.Println(request.Method, request.URI, request.Protocol, request.HTTPVersion, "base_"+request.Method)
		for i := 0; i < a; i++ {
			temp := request.Protocol[i]
			for x := 0; x < len(charset); x++ {
				c := strings.Replace(request.Protocol, string(temp), string(charset[rand.Intn(len(charset))]), 1)
				if c != request.Protocol && string(temp) != string(charset[x]) {
					finalString := request.Method + " " + request.URI + " " + c + " " + request.HTTPVersion
					if inMap(finalString) {
						fmt.Println(request.Method, request.URI, c, request.HTTPVersion, "sw3_"+request.Method+"_"+strconv.Itoa(count))
						replacedCount++
						count++
					}

				}

			}
		}
	case part == 4:
		a := len(request.HTTPVersion)
		count := 1
		// fmt.Println(request.Method, request.URI, request.Protocol, request.HTTPVersion, "base_"+request.Method)
		for i := 0; i < a; i++ {
			temp := request.HTTPVersion[i]
			for x := 0; x < len(charset); x++ {
				c := strings.Replace(request.HTTPVersion, string(temp), string(digits[rand.Intn(len(digits))]), 1)
				if c != request.HTTPVersion && string(temp) != string(charset[x]) {
					finalString := request.Method + " " + request.URI + " " + request.Protocol + " " + c
					if inMap(finalString) {
						fmt.Println(request.Method, request.URI, request.Protocol, c, "sw4_"+request.Method+"_"+strconv.Itoa(count))
						replacedCount++
						count++
					}

				}

			}
		}
	}
}

func createRequest(method string, url string, proto string, version string) requestLine {
	var req requestLine
	req.Method = method
	req.URI = url
	req.Protocol = proto
	req.HTTPVersion = version
	donorCount++
	return req
}

// func delChar(s []rune, index int) []rune {
// 	return append(s[0:index], s[index+1:]...)
// }
